import time
import _thread
import urequests
import network
from machine import Pin, I2C
from ssd1306 import SSD1306_I2C
state = 0
station = 2
gr = 'g'
rd = 'r'
bl = 'b'
#state = 0 : station IDLE
#state = 1 : station ARRIVE
#state = 2 : station READY
#state = 3 : station TRAIN_OUT back to 0
press = False
def do_connect():
    wlan = network.WLAN(network.STA_IF)
    wlan.active(True)
    if not wlan.isconnected():
        print('connecting to network...')
        wlan.connect('Andriod AP', 'HelloiTMe(135).')
        while not wlan.isconnected():
            pass
    print('network config:', wlan.ifconfig())
    return wlan
def set_led(cl):
    led_rd.off()
    led_gr.off()
    led_bl.off()
    if cl == 'g': led_gr.on()
    if cl == 'r': led_rd.on()
    if cl == 'b': led_bl.on()
wlan1 = do_connect()
def oled_set_status(oled,station_number, state):
    oled.fill(0)
    response = urequests.get('http://train-station.herokuapp.com/station/arrived/0')
    resp = response.json()
    if(station_number == 1 or station_number == 2):
        if(resp['train']['status'] == 'error'):
            set_led(bl)
            oled.text('Error has occurred',0,30)
        elif(resp['train']['status'] == 'stay'):
            set_led(gr)
            oled.text('Train at station',0,30)
        elif(resp['train']['status'] == 'going'):
            set_led(rd)
            oled.text('Train is traveling',0,30)
        elif(resp['train']['status'] == 'waiting'):
            set_led(gr)
            oled.text('Hurry up the train',0,30)
        oled.show()
    else:
        pass
    oled.show()
    
def oled_show_station_status(oled,station_number, state):
    oled.fill(0)
    response2 = urequests.get('http://train-station.herokuapp.com/station/getTrain?which=0')
    resp2 = response2.json()
    if(station_number == 1):
        oled.text("Station A",0,0)
        if(resp2['train']['status'] == 'error'):
            set_led(bl)
            oled.text('Error has',0,20)
            oled.text('occurred',0,30)
        elif(resp2['train']['status'] == 'stay'):
            set_led(gr)
            oled.text('Train at station',0,20)
        elif(resp2['train']['status'] == 'going'):
            set_led(rd)
            oled.text("Train is",0,20)
            oled.text("traveling",0,30)
        elif(resp2['train']['status'] == 'waiting'):
            set_led(gr)
            oled.text('Hurry up',0,20)
            
        oled.show()
    elif(station_number == 2):
        oled.text("Station B",0,0)
        if(resp2['train']['status'] == 'error'):
            set_led(bl)
            oled.text('Error has',0,20)
            oled.text('occurred',0,30)
        elif(resp2['train']['status'] == 'stay'):
            set_led(gr)
            oled.text('Train at station',0,20)
        elif(resp2['train']['status'] == 'going'):
            set_led(rd)
            oled.text("Train is",0,20)
            oled.text("traveling",0,30)
        elif(resp2['train']['status'] == 'waiting'):
            set_led(gr)
            oled.text('Hurry up',0,20)
            
        oled.show()
    else:
        pass
    oled.show()




i2c = I2C(scl=Pin(22),sda=Pin(21),freq=100000)
oled = SSD1306_I2C(128,64,i2c)
led_gr = Pin(12, Pin.OUT)
led_rd = Pin(14, Pin.OUT)
led_bl = Pin(2, Pin.OUT)
print(i2c.scan())
#print("Send data to STM32...")
#i2c.writeto(0x50, b'Hello from ESP32')


while(1):
    oled_show_station_status(oled,1,state)
    x = i2c.readfrom(0x50,3)
    sw = (x == bytes('ON ','utf8'))
    print(sw)
    print(state)
    if(sw):
        print('press')
        state += 1
        print(state)
        oled.text('Error has',0,20)
        oled.text('occurred',0,30)
        oled.show()
        oled_set_status(oled,1,state)
    time.sleep(1)